#Makefile

SOURCE_FILES= \
             $(CONVECT)/acmcld.f90 \
             $(CONVECT)/cuparm_driver.f90 \
             $(CONVECT)/mem_cuparm.f90 \
             $(CONVECT)/mem_turb.f90 \
             $(CONVECT)/module_bl_acm2.f90 \
             $(CONVECT)/module_cu_emanuel.f90 \
             $(CONVECT)/module_cu_g3.f90 \
             $(CONVECT)/module_cu_gf.f90 \
             $(CONVECT)/module_cu_kfeta.f90 \
             $(CONVECT)/module_cu_tiedtke.f90 \
             $(CONVECT)/pbl_driver.f90 \
             $(CONVECT)/smagorinsky.f90 \
             $(ED2MEM)/ed_max_dims.F90 \
             $(ED2MEM)/ed_misc_coms.f90 \
             $(LEAF)/land_database_read.f90 \
             $(LEAF)/leaf4.F90 \
             $(LEAF)/leaf4_canopy.f90 \
             $(LEAF)/leaf4_coms.f90 \
             $(LEAF)/leaf4_init_atm.f90 \
             $(LEAF)/leaf4_landcell.f90 \
             $(LEAF)/leaf4_plot.f90 \
             $(LEAF)/leaf4_sfcwater.f90 \
             $(LEAF)/leaf4_soil.f90 \
             $(LEAF)/leaf4_startup.f90 \
             $(LEAF)/mem_leaf.f90 \
             $(LEAF)/ndvi_database_read.f90 \
             $(LEAF)/para_init_land.f90 \
             $(LEAF)/read_soil_analysis.F90 \
             $(MODEL_MODS)/consts_coms.f90 \
             $(MODEL_MODS)/ke_coms.f90 \
             $(MODEL_MODS)/max_dims.f90 \
             $(MODEL_MODS)/mem_addgrid.f90 \
             $(MODEL_MODS)/mem_addsc.f90 \
             $(MODEL_MODS)/mem_adv.f90 \
             $(MODEL_MODS)/mem_average_vars.f90 \
             $(MODEL_MODS)/mem_basic.f90 \
             $(MODEL_MODS)/mem_co2.f90 \
             $(MODEL_MODS)/mem_flux_accum.f90 \
             $(MODEL_MODS)/mem_grid.f90 \
             $(MODEL_MODS)/mem_ijtabs.f90 \
             $(MODEL_MODS)/mem_micro.f90 \
             $(MODEL_MODS)/mem_mksfc2.f90 \
             $(MODEL_MODS)/mem_nudge.f90 \
             $(MODEL_MODS)/mem_para.F90 \
             $(MODEL_MODS)/mem_plot.f90 \
             $(MODEL_MODS)/mem_rayf.f90 \
             $(MODEL_MODS)/mem_tend.f90 \
             $(MODEL_MODS)/mem_zonavg.f90 \
             $(MODEL_MODS)/micro_coms.f90 \
             $(MODEL_MODS)/misc_coms.f90 \
             $(MODEL_MODS)/nuclei_coms.f90 \
             $(MODEL_MODS)/olam_mpi_atm.F90 \
             $(MODEL_MODS)/oname_coms.f90 \
             $(MODEL_MODS)/oplot_coms.f90 \
             $(MODEL_MODS)/plotcolors.f90 \
             $(MODEL_MODS)/var_tables.f90 \
             $(OISAN)/asti.f90 \
             $(OISAN)/astp.F90 \
             $(OISAN)/file_inv.f90 \
             $(OISAN)/fldsisan.f90 \
             $(OISAN)/isan_coms.f90 \
             $(OISAN)/isan_driver.f90 \
             $(OISAN)/nudge_o3.f90 \
             $(OISAN)/obs_nudge.f90 \
             $(OISAN)/spec_nudge.f90 \
             $(OMODEL)/alloc.f90 \
             $(OMODEL)/average_vars.f90 \
             $(OMODEL)/cartesian.f90 \
             $(OMODEL)/cart_hex.f90 \
             $(OMODEL)/coneplot.f90 \
             $(OMODEL)/contslab.F90 \
             $(OMODEL)/fields2_ll.F90 \
             $(OMODEL)/fill_itabs.f90 \
             $(OMODEL)/hex_grid.f90 \
             $(OMODEL)/history_start.f90 \
             $(OMODEL)/history_write.f90 \
             $(OMODEL)/icosahedron.f90 \
             $(OMODEL)/lateral_friction.f90 \
             $(OMODEL)/lite_vars.f90 \
             $(OMODEL)/makesfc2.f90 \
             $(OMODEL)/nuclei_deposition.f90 \
             $(OMODEL)/obnd.f90 \
             $(OMODEL)/ocio.f90 \
             $(OMODEL)/ohhi.f90 \
             $(OMODEL)/olam_grid.f90 \
             $(OMODEL)/olammain.F90 \
             $(OMODEL)/olamplot.f90 \
             $(OMODEL)/olam_run.F90 \
             $(OMODEL)/olhi.f90 \
             $(OMODEL)/omic_coll.f90 \
             $(OMODEL)/omic_driv.f90 \
             $(OMODEL)/omic_gamma.f90 \
             $(OMODEL)/omic_init.f90 \
             $(OMODEL)/omic_misc.f90 \
             $(OMODEL)/omic_nuc.f90  \
             $(OMODEL)/omic_parcel.f90  \
             $(OMODEL)/omic_tabs.f90 \
             $(OMODEL)/omic_vap.f90 \
             $(OMODEL)/oname_check.f90 \
             $(OMODEL)/oname.f90 \
             $(OMODEL)/oplot_interface.F90 \
             $(OMODEL)/oplot_lib.f90 \
             $(OMODEL)/othrm.f90 \
             $(OMODEL)/para_decomp.f90 \
             $(OMODEL)/para_init.f90 \
             $(OMODEL)/prog_wrtv.f90 \
             $(OMODEL)/salt_dust_src.f90 \
             $(OMODEL)/scalar_transport.f90 \
             $(OMODEL)/spawn_nest.f90 \
             $(OMODEL)/spring_dynamics.f90 \
             $(OMODEL)/surface_fluxes.F90 \
             $(OMODEL)/thuburn_module.F90 \
             $(OMODEL)/tileslab.F90 \
             $(OMODEL)/timestep.f90 \
             $(OMODEL)/triangle_utils.f90 \
             $(OMODEL)/vectslab.F90 \
             $(OMODEL)/vel_t3d.f90 \
             $(OUTILS)/blas.f90 \
             $(OUTILS)/check_nans.F90 \
             $(OUTILS)/dateutils.f90 \
             $(OUTILS)/hdf5_f2f.F90 \
             $(OUTILS)/hdf5_utils.F90 \
             $(OUTILS)/interp_lib.f90 \
             $(OUTILS)/lapack.f90 \
             $(OUTILS)/map_proj.f90 \
             $(OUTILS)/matrix.f90 \
             $(OUTILS)/olam_interp_ll.f90 \
             $(OUTILS)/o_ncar.f90 \
             $(OUTILS)/polygon_overlap.f90 \
             $(OUTILS)/prfill.f90 \
             $(OUTILS)/quadrature.f90 \
             $(OUTILS)/read_cdc.f90 \
             $(OUTILS)/string_lib.f90 \
             $(OUTILS)/therm_lib.f90 \
             $(OUTILS)/tridiag_lib.f90 \
             $(RADIATE)/cloud_frac.f90 \
             $(RADIATE)/cloudprep_rad.f90 \
             $(RADIATE)/clouds_gno.f90 \
             $(RADIATE)/mem_mclat.f90 \
             $(RADIATE)/mem_radiate.f90 \
             $(RADIATE)/rad_driv.F90 \
             $(RADIATE)/rrtmg_cloud_optics.f90 \
             $(RADIATE)/rrtmg_raddriv.f90 \
             $(RADIATE)/rrtmg_lw/mcica_subcol_gen_lw.f90 \
             $(RADIATE)/rrtmg_lw/parkind.f90 \
             $(RADIATE)/rrtmg_lw/parrrtm.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_cld.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_con.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg01.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg02.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg03.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg04.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg05.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg06.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg07.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg08.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg09.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg10.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg11.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg12.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg13.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg14.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg15.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_kg16.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_ncpar.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_ref.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_tbl.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_vsn.f90 \
             $(RADIATE)/rrtmg_lw/rrlw_wvn.f90 \
             $(RADIATE)/rrtmg_lw/rrtmg_lw_cldprmc.f90 \
             $(RADIATE)/rrtmg_lw/rrtmg_lw_init.f90 \
             $(RADIATE)/rrtmg_lw/rrtmg_lw_rad.f90 \
             $(RADIATE)/rrtmg_lw/rrtmg_lw_read_h5.f90 \
             $(RADIATE)/rrtmg_lw/rrtmg_lw_rtrnmc.f90 \
             $(RADIATE)/rrtmg_lw/rrtmg_lw_setcoef.f90 \
             $(RADIATE)/rrtmg_lw/rrtmg_lw_taumol.f90 \
             $(RADIATE)/rrtmg_sw/mcica_subcol_gen_sw.f90 \
             $(RADIATE)/rrtmg_sw/parrrsw.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_aer.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_cld.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_con.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg16.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg17.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg18.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg19.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg20.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg21.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg22.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg23.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg24.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg25.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg26.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg27.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg28.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_kg29.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_ncpar.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_ref.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_tbl.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_vsn.f90 \
             $(RADIATE)/rrtmg_sw/rrsw_wvn.f90 \
             $(RADIATE)/rrtmg_sw/rrtmg_sw_cldprmc.f90 \
             $(RADIATE)/rrtmg_sw/rrtmg_sw_init.f90 \
             $(RADIATE)/rrtmg_sw/rrtmg_sw_rad.f90 \
             $(RADIATE)/rrtmg_sw/rrtmg_sw_read_h5.f90 \
             $(RADIATE)/rrtmg_sw/rrtmg_sw_setcoef.f90 \
             $(RADIATE)/rrtmg_sw/rrtmg_sw_spcvmc.f90 \
             $(RADIATE)/rrtmg_sw/rrtmg_sw_taumol.f90 \
             $(SEA)/mem_sea.f90 \
             $(SEA)/para_init_sea.f90 \
             $(SEA)/read_seaice_analysis.F90 \
             $(SEA)/read_sst_analysis.F90 \
             $(SEA)/sea_coms.f90 \
             $(SEA)/sea.f90 \
             $(SEA)/seaice_database_read.f90 \
             $(SEA)/seaice.f90 \
             $(SEA)/sea_init_atm.f90 \
             $(SEA)/sea_startup.f90 \
             $(SEA)/sst_database_read.f90 \
             $(HURRICANE)/hurricane_init.f90 \
             $(TEST_CASES)/mem_swtc5_refsoln_cubic.f90 \
             $(TEST_CASES)/swtc_init.f90 \
             $(TEST_CASES)/diagn_global_swtc.F90 \
             $(TEST_CASES)/dcmip_initial_conditions_test_1_2_3_v5.f90 \
             $(TEST_CASES)/dcmip_initial_conditions_test_4_v2_1.f90 \
             $(TEST_CASES)/test2xdeep.f90 \
             $(TEST_CASES)/test41alt.f90 \
             $(TEST_CASES)/DCMIP2016/baroclinic_wave_test.f90 \
             $(TEST_CASES)/DCMIP2016/diagn_global_dcmip.F90 \
             $(TEST_CASES)/DCMIP2016/kessler.f90 \
             $(TEST_CASES)/DCMIP2016/olam_dcmip3.f90 \
             $(TEST_CASES)/DCMIP2016/dcmip_physics_z_v1.f90 \
             $(TEST_CASES)/DCMIP2016/supercell_test.f90 \
             $(TEST_CASES)/DCMIP2016/Terminator.f90 \
             $(TEST_CASES)/DCMIP2016/tropical_cyclone_test.f90 \
             $(CMAQ)/AERO_DATA.F \
             $(CMAQ)/aero_depv.F \
             $(CMAQ)/aero_driver.F \
             $(CMAQ)/AERO_EMIS.F \
             $(CMAQ)/AERO_PHOTDATA.F \
             $(CMAQ)/aero_subs.F \
             $(CMAQ)/AEROMET_DATA.F \
             $(CMAQ)/AEROSOL_CHEMISTRY.F \
             $(CMAQ)/AOD_DEFN.F \
             $(CMAQ)/AQ_DATA.F \
             $(CMAQ)/aq_map.F \
             $(CMAQ)/aqchem.F \
             $(CMAQ)/cb05tucl_ae6_aq/RXNS_DATA_MODULE.F90 \
             $(CMAQ)/cb05tucl_ae6_aq/RXNS_FUNC_MODULE.F90 \
             $(CMAQ)/cmaq_cloud_optics.f90 \
             $(CMAQ)/cmaq_driver.f90 \
             $(CMAQ)/coags.f \
             $(CMAQ)/CONST_DATA.f90 \
             $(CMAQ)/conv_cgrid.f90 \
             $(CMAQ)/cgrid_defn.f90 \
             $(CMAQ)/CGRID_SPCS.F \
             $(CMAQ)/CSQY_DATA.F \
             $(CMAQ)/czangle.F \
             $(CMAQ)/DEPV_DEFN.F \
             $(CMAQ)/DEPVVARS.F \
             $(CMAQ)/DUST_EMIS.F \
             $(CMAQ)/edgar_42_emis.F90 \
             $(CMAQ)/EMIS_DEFN.F \
             $(CMAQ)/findex.f \
             $(CMAQ)/gas_depv_map.F \
             $(CMAQ)/geia_emis.F90 \
             $(CMAQ)/getalpha.F \
             $(CMAQ)/getpar.f \
             $(CMAQ)/hlconst.F \
             $(CMAQ)/hrdata_mod.F \
             $(CMAQ)/hrdriver.F \
             $(CMAQ)/hrg1.F \
             $(CMAQ)/hrg2.F \
             $(CMAQ)/hrg3.F \
             $(CMAQ)/hrg4.F \
             $(CMAQ)/hrinit.F \
             $(CMAQ)/hrprodloss.F \
             $(CMAQ)/hrrates.F \
             $(CMAQ)/hrsolver.F \
             $(CMAQ)/indexn.f \
             $(CMAQ)/init_cgrid.f90 \
             $(CMAQ)/isocom.f \
             $(CMAQ)/isofwd.f \
             $(CMAQ)/isorev.f \
             $(CMAQ)/isrpia.f90 \
             $(CMAQ)/LTNG_DEFN.f90 \
             $(CMAQ)/m3dry.f90 \
             $(CMAQ)/oplot_chem_lib.f90 \
             $(CMAQ)/phot.F \
             $(CMAQ)/phot_albedo.f90 \
             $(CMAQ)/PHOT_MOD.F \
             $(CMAQ)/PMDIAG_DATA.F \
             $(CMAQ)/PRECURSOR_DATA.F \
             $(CMAQ)/rescld.F \
             $(CMAQ)/scavwdep.F \
             $(CMAQ)/sedv_defn.f90 \
             $(CMAQ)/setup_logdev.F \
             $(CMAQ)/SOA_DEFN.F \
             $(CMAQ)/soil_nox.f90 \
             $(CMAQ)/SSEMIS.F \
             $(CMAQ)/twoway_rrtmg_aero_optics.F90 \
             $(CMAQ)/UTILIO_DEFN.F \
             $(MEGAN)/CONSTS_MEGAN.f90 \
             $(MEGAN)/EMIS_MAPS_MEGAN.f90 \
             $(MEGAN)/megan_driver.F90

ED2_SOURCES = \
             $(ED2DRIV)/ed_1st.f90 \
             $(ED2DRIV)/ed_driver.f90 \
             $(ED2DRIV)/ed_met_driver.f90 \
             $(ED2DRIV)/ed_model.f90 \
             $(ED2DRIV)/ed_wrappers.f90 \
             $(ED2DRIV)/copy_olam_to_ed.f90 \
             $(ED2DYN)/canopy_struct_dynamics.f90 \
             $(ED2DYN)/disturbance.f90 \
             $(ED2DYN)/euler_driver.f90 \
             $(ED2DYN)/events.f90 \
             $(ED2DYN)/farq_leuning.f90 \
             $(ED2DYN)/fire.f90 \
             $(ED2DYN)/forestry.f90 \
             $(ED2DYN)/growth_balive.f90 \
             $(ED2DYN)/heun_driver.f90 \
             $(ED2DYN)/lsm_hyd.f90 \
             $(ED2DYN)/mortality.f90 \
             $(ED2DYN)/phenology_aux.f90 \
             $(ED2DYN)/phenology_driv.f90 \
             $(ED2DYN)/photosyn_driv.f90 \
             $(ED2DYN)/radiate_driver.f90 \
             $(ED2DYN)/reproduction.f90 \
             $(ED2DYN)/rk4_derivs.F90 \
             $(ED2DYN)/rk4_driver.F90 \
             $(ED2DYN)/rk4_integ_utils.f90 \
             $(ED2DYN)/rk4_misc.f90 \
             $(ED2DYN)/rk4_stepper.f90 \
             $(ED2DYN)/soil_respiration.f90 \
             $(ED2DYN)/structural_growth.f90 \
             $(ED2DYN)/twostream_rad.f90 \
             $(ED2DYN)/vegetation_dynamics.f90 \
             $(ED2INIT)/ed_init.f90 \
             $(ED2INIT)/ed_init_atm.F90 \
             $(ED2INIT)/ed_nbg_init.f90 \
             $(ED2INIT)/ed_params.f90 \
             $(ED2INIT)/ed_type_init.f90 \
             $(ED2INIT)/init_hydro_sites.f90 \
             $(ED2INIT)/landuse_init.f90 \
             $(ED2INIT)/phenology_startup.f90 \
             $(ED2IO)/an_header.f90 \
             $(ED2IO)/average_utils.f90 \
             $(ED2IO)/ed_init_full_history.F90 \
             $(ED2IO)/ed_load_namelist.f90 \
             $(ED2IO)/ed_opspec.F90 \
             $(ED2IO)/ed_print.f90 \
             $(ED2IO)/ed_read_ed10_20_history.f90 \
             $(ED2IO)/ed_read_ed21_history.F90 \
             $(ED2IO)/ed_xml_config.f90 \
             $(ED2IO)/edio.f90 \
             $(ED2IO)/h5_output.F90 \
             $(ED2IO)/leaf_database.f90 \
             $(ED2MEM)/c34constants.f90 \
             $(ED2MEM)/canopy_air_coms.f90 \
             $(ED2MEM)/canopy_layer_coms.f90 \
             $(ED2MEM)/canopy_radiation_coms.f90 \
             $(ED2MEM)/decomp_coms.f90 \
             $(ED2MEM)/disturb_coms.f90 \
             $(ED2MEM)/ed_consts_coms.F90 \
             $(ED2MEM)/ed_mem_alloc.f90 \
             $(ED2MEM)/ed_mem_grid_dim_defs.f90 \
             $(ED2MEM)/ed_state_vars.f90 \
             $(ED2MEM)/ed_var_tables.f90 \
             $(ED2MEM)/ed_work_vars.f90 \
             $(ED2MEM)/ename_coms.f90 \
             $(ED2MEM)/fusion_fission_coms.f90 \
             $(ED2MEM)/grid_coms.f90 \
             $(ED2MEM)/ed_hdf5_coms.F90 \
             $(ED2MEM)/hydrology_coms.f90 \
             $(ED2MEM)/hydrology_constants.f90 \
             $(ED2MEM)/mem_polygons.f90 \
             $(ED2MEM)/met_driver_coms.f90 \
             $(ED2MEM)/optimiz_coms.f90 \
             $(ED2MEM)/pft_coms.f90 \
             $(ED2MEM)/phenology_coms.f90 \
             $(ED2MEM)/physiology_coms.f90 \
             $(ED2MEM)/rk4_coms.f90 \
             $(ED2MEM)/soil_coms.F90 \
             $(ED2MPI)/ed_mpass_init.f90 \
             $(ED2MPI)/ed_node_coms.f90 \
             $(ED2MPI)/ed_para_coms.f90 \
             $(ED2MPI)/ed_para_init.F90 \
             $(ED2UTILS)/allometry.f90 \
             $(ED2UTILS)/budget_utils.f90 \
             $(ED2UTILS)/charutils.f90 \
             $(ED2UTILS)/ed_dateutils.f90 \
             $(ED2UTILS)/ed_filelist.F90 \
             $(ED2UTILS)/ed_grid.f90 \
             $(ED2UTILS)/sp_therm_lib.f90 \
             $(ED2UTILS)/fatal_error.f90 \
             $(ED2UTILS)/fuse_fiss_utils.f90 \
             $(ED2UTILS)/great_circle.f90 \
             $(ED2UTILS)/ed_hdf5_utils.F90 \
             $(ED2UTILS)/invmondays.f90 \
             $(ED2UTILS)/lapse.f90 \
             $(ED2UTILS)/libxml2f90.f90_pp.f90 \
             $(ED2UTILS)/numutils.f90 \
             $(ED2UTILS)/radiate_utils.f90 \
             $(ED2UTILS)/rsys.F90 \
             $(ED2UTILS)/stable_cohorts.f90 \
             $(ED2UTILS)/ed_therm_lib.f90 \
             $(ED2UTILS)/dp_therm_lib.f90 \
             $(ED2UTILS)/update_derived_props.f90 \
             $(ED2UTILS)/utils_c.c \
             $(ED2UTILS)/utils_f.f90
